Overview | Package | Class | Tree | Deprecated | Index | Help
| Xerces 1.2.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xml.serialize
Class TextSerializer

    java.lang.Object
      |
      +--org.apache.xml.serialize.BaseMarkupSerializer
            |
            +--org.apache.xml.serialize.TextSerializer

All Implemented Interfaces:
  ContentHandler, DeclHandler, DocumentHandler, DOMSerializer, DTDHandler, LexicalHandler, Serializer

public final class TextSerializer
extends BaseMarkupSerializer

Implements a text serializer supporting both DOM and SAX serializing. For usage instructions see `Serializer`.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. DOM serializing is done by calling `BaseMarkupSerializer.serialize(org.w3c.dom.Element)` and SAX serializing is done by firing SAX events and using the serializer as a document handler.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

Version:
  $Revision: 1.7 $ $Date: 2000/08/30 18:59:22 $
See Also:
  `Serializer`

Fields inherited from class org.apache.xml.serialize.BaseMarkupSerializer
`_docTypePublicId, _docTypeSystemId, _format, _indenting, _prefixes, _printer, _started`

Constructor Summary
`TextSerializer()` Constructs a new serializer.

Method Summary
`void` | `characters(char[] chars, int start, int length)` Receive notification of character data.
`protected void` | `characters(java.lang.String text, boolean unescaped)`
`void` | `comment(char[] chars, int start, int length)` Report an XML comment anywhere in the document.
`void` | `comment(java.lang.String text)`
`protected org.apache.xml.serialize.ElementState` | `content()` Must be called by a method about to print any type of content.
`void` | `endElement(java.lang.String tagName)` Receive notification of the end of an element.
`void` | `endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)` Receive notification of the end of an element.
`protected java.lang.String` | `getEntityRef(char ch)` Returns the suitable entity reference for this character value, or null if no such entity exists.
`void` | `processingInstruction(java.lang.String target, java.lang.String code)` Receive notification of a processing instruction.
`protected void` | `serializeElement(Element elem)` Called to serialize a DOM element.
`protected void` | `serializeNode(Node node)` Serialize the DOM node.
`void` | `setOutputFormat(OutputFormat format)` Specifies an output format for this serializer.
`protected void` | `startDocument(java.lang.String rootTagName)` Called to serialize the document's DOCTYPE by the root element.
`void` | `startElement(java.lang.String tagName, AttributeList attrs)` Receive notification of the beginning of an element.
`void` | `startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName, Attributes attrs)` Receive notification of the beginning of an element.

Methods inherited from class org.apache.xml.serialize.BaseMarkupSerializer
`asContentHandler, asDocumentHandler, asDOMSerializer, attributeDecl, characters, elementDecl, endCDATA, endDocument, endDTD, endEntity, endNonEscaping, endPrefixMapping, endPreserving, enterElementState, externalEntityDecl, getElementState, getPrefix, ignorableWhitespace, internalEntityDecl, isDocumentState, leaveElementState, notationDecl, prepare, printDoctypeURL, printEscaped, printEscaped, printText, printText, reset, serialize, serialize, serialize, serializePreRoot, setDocumentLocator, setOutputByteStream, setOutputCharStream, skippedEntity, startCDATA, startDocument, startDTD, startEntity, startNonEscaping, startPrefixMapping, startPreserving, unparsedEntityDecl`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TextSerializer

    public TextSerializer()

  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

Method Detail

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Description copied from interface: `Serializer`
  Specifies an output format for this serializer. It the serializer has already been associated with an output format, it will switch to the new format. This method should not be called while the serializer is in the process of serializing a document.
  Overrides:
    `setOutputFormat` in class `BaseMarkupSerializer`
  Following copied from interface: `org.apache.xml.serialize.Serializer`
  Parameters:
    `format` - The output format to use

### startElement

    public void startElement(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName,
                             Attributes attrs)

  Description copied from interface: `ContentHandler`
  Receive notification of the beginning of an element.

  The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding `endElement` event for every startElement event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement event.

  This event allows up to three name components for each element:

  1. the Namespace URI;
  2. the local name; and
  3. the qualified (prefixed) name.

  Any or all of these may be provided, depending on the values of the http://xml.org/sax/features/namespaces and the http://xml.org/sax/features/namespace-prefixes properties:

  - the Namespace URI and local name are required when the namespaces property is true (the default), and are optional when the namespaces property is false (if one is specified, both must be);
  - the qualified name is required when the namespace-prefixes property is true, and is optional when the namespace-prefixes property is false (the default).

  Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted. The attribute list will contain attributes used for Namespace declarations (xmlns* attributes) only if the `http://xml.org/sax/features/namespace-prefixes` property is true (it is false by default, and support for a true value is optional).

  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `uri` - The Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed.
    `localName` - The local name (without prefix), or the empty string if Namespace processing is not being performed.
    `qName` - The qualified name (with prefix), or the empty string if qualified names are not available.
    `atts` - The attributes attached to the element. If there are no attributes, it shall be an empty Attributes object.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`, `Attributes`

### endElement

    public void endElement(java.lang.String namespaceURI,
                           java.lang.String localName,
                           java.lang.String rawName)

  Description copied from interface: `ContentHandler`
  Receive notification of the end of an element.

  The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding `startElement` event for every endElement event (even when the element is empty).

  For information on the names, see startElement.

  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `uri` - The Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed.
    `localName` - The local name (without prefix), or the empty string if Namespace processing is not being performed.
    `qName` - The qualified XML 1.0 name (with prefix), or the empty string if qualified names are not available.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.

### startElement

    public void startElement(java.lang.String tagName,
                             AttributeList attrs)

  Description copied from interface: `DocumentHandler`
  Receive notification of the beginning of an element.

  The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding endElement() event for every startElement() event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement() event.

  If the element name has a namespace prefix, the prefix will still be attached. Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted.

  Following copied from interface: `org.xml.sax.DocumentHandler`
  Parameters:
    `name` - The element type name.
    `atts` - The attributes attached to the element, if any.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `DocumentHandler.endElement(java.lang.String)`, `AttributeList`

### endElement

    public void endElement(java.lang.String tagName)

  Description copied from interface: `DocumentHandler`
  Receive notification of the end of an element.

  The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding startElement() event for every endElement() event (even when the element is empty).

  If the element name has a namespace prefix, the prefix will still be attached to the name.

  Following copied from interface: `org.xml.sax.DocumentHandler`
  Parameters:
    `name` - The element type name
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.

### processingInstruction

    public void processingInstruction(java.lang.String target,
                                      java.lang.String code)

  Description copied from interface: `ContentHandler`
  Receive notification of a processing instruction.

  The Parser will invoke this method once for each processing instruction found: note that processing instructions may occur before or after the main document element.

  A SAX parser must never report an XML declaration (XML 1.0, section 2.8) or a text declaration (XML 1.0, section 4.3.1) using this method.

  Overrides:
    `processingInstruction` in class `BaseMarkupSerializer`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `target` - The processing instruction target.
    `data` - The processing instruction data, or null if none was supplied. The data does not include any whitespace separating it from the target.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.

### comment

    public void comment(java.lang.String text)

  Overrides:
    `comment` in class `BaseMarkupSerializer`

### comment

    public void comment(char[] chars,
                        int start,
                        int length)

  Description copied from interface: `LexicalHandler`
  Report an XML comment anywhere in the document.

  This callback will be used for comments inside or outside the document element, including comments in the external DTD subset (if read).

  Overrides:
    `comment` in class `BaseMarkupSerializer`
  Following copied from interface: `org.xml.sax.ext.LexicalHandler`
  Parameters:
    `ch` - An array holding the characters in the comment.
    `start` - The starting position in the array.
    `length` - The number of characters to use from the array.
  Throws:
    `SAXException` - The application may raise an exception.

### characters

    public void characters(char[] chars,
                           int start,
                           int length)

  Description copied from interface: `ContentHandler`
  Receive notification of character data.

  The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity so that the Locator provides useful information.

  The application must not attempt to read from the array outside of the specified range.

  Note that some parsers will report whitespace in element content using the `ignorableWhitespace` method rather than this one (validating parsers must do so).

  Overrides:
    `characters` in class `BaseMarkupSerializer`
  Following copied from interface: `org.xml.sax.ContentHandler`
  Parameters:
    `ch` - The characters from the XML document.
    `start` - The start position in the array.
    `length` - The number of characters to read from the array.
  Throws:
    `SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.ignorableWhitespace(char[], int, int)`, `Locator`

### characters

    protected void characters(java.lang.String text,
                              boolean unescaped)

### startDocument

    protected void startDocument(java.lang.String rootTagName)

  Called to serialize the document's DOCTYPE by the root element.

  This method will check if it has not been called before (`BaseMarkupSerializer._started`), will serialize the document type declaration, and will serialize all pre-root comments and PIs that were accumulated in the document (see `BaseMarkupSerializer.serializePreRoot()`). Pre-root will be serialized even if this is not the first root element of the document.

### serializeElement

    protected void serializeElement(Element elem)

  Called to serialize a DOM element. Equivalent to calling `startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`, `endElement(java.lang.String, java.lang.String, java.lang.String)` and serializing everything inbetween, but better optimized.
  Overrides:
    `serializeElement` in class `BaseMarkupSerializer`
  Following copied from class: `org.apache.xml.serialize.BaseMarkupSerializer`
  Parameters:
    `elem` - The element to serialize

### serializeNode

    protected void serializeNode(Node node)

  Serialize the DOM node. This method is unique to the Text serializer.
  Overrides:
    `serializeNode` in class `BaseMarkupSerializer`
  Parameters:
    `node` - The node to serialize

### content

    protected org.apache.xml.serialize.ElementState content()

  Description copied from class: `BaseMarkupSerializer`
  Must be called by a method about to print any type of content. If the element was just opened, the opening tag is closed and will be matched to a closing tag. Returns the current element state with `empty` and `afterElement` set to false.
  Overrides:
    `content` in class `BaseMarkupSerializer`
  Following copied from class: `org.apache.xml.serialize.BaseMarkupSerializer`
  Returns:
    The current element state

### getEntityRef

    protected java.lang.String getEntityRef(char ch)

  Description copied from class: `BaseMarkupSerializer`
  Returns the suitable entity reference for this character value, or null if no such entity exists. Calling this method with `'&'` will return `"&amp;"`.
  Overrides:
    `getEntityRef` in class `BaseMarkupSerializer`
  Following copied from class: `org.apache.xml.serialize.BaseMarkupSerializer`
  Parameters:
    `ch` - Character value
  Returns:
    Character entity name, or null

Overview | Package | Class | Tree | Deprecated | Index | Help
| Xerces 1.2.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD